-- Uebung 7
-- Aufgabe 1
max_Anzahl::[Int]->(Int,Int)
max_Anzahl [] = error"Leere Liste"
max_Anzahl l = (maximum l, count l (maximum l))

count::[Int]->Int->Int
count [] _ = 0
count (a:l) b = if a == b then (count l b) + 1 else count l b


-- Aufgabe 2
-- Ausleihe einer Biblithek (vereinfachtes Modell)

type Benutzer = String
type Buch = String

type Datenbank = [(Benutzer,Buch)] -- Datenbank der Ausleihe

beispielAusleihe :: Datenbank
beispielAusleihe = [("Anna","Asterix"),("Berta","Obelix"),("Anna","Obelix")]

-- Lesende Funktionen (Lookup functions)

gelieheneBcher :: Datenbank -> Benutzer -> [Buch]
gelieheneBcher db p = [buch | (ben,buch) <- db, ben == p ]

leiher :: Datenbank -> Buch -> [Benutzer]
leiher db b = [ben | (ben,buch) <- db, buch == b ]

anzGelBcher:: Datenbank -> Benutzer -> Int
anzGelBcher db p = length (gelieheneBcher db p)

anzEntliehen db b = length (leiher db b)
-- Schreibende Funktionen (Update functions)

ausleihe :: Datenbank -> Benutzer -> Buch -> Datenbank
ausleihe db p b = (p,b) : db

rckgabe :: Datenbank -> Benutzer -> Buch -> Datenbank
rckgabe [] p b = error ("Der Benutzer " ++ p ++ "hat das Buch " ++ b ++
                        "nicht entliehen und kann es daher nicht zurckgeben!")
rckgabe (benbuch:db) p b = if benbuch == (p,b) then db else benbuch : rckgabe db p b

test1 :: Datenbank
test1 = ausleihe beispielAusleihe "Csar" "Kleopatra"

test2 :: Datenbank
test2 = rckgabe test1 "Berta" "Obelix"

--------------------

-- Aufgabe 3
type Datenbank2 = [(Benutzer,[Buch])]
beispielAusleihe2 :: Datenbank2
beispielAusleihe2 = [("Anna",["Asterix", "Obelix"]),("Berta",["Obelix"]),("Helga",["Obelix","Idefix","Asterix"])]

-- Lesende Funktionen (Lookup functions)

gelieheneBcher2 :: Datenbank -> Benutzer -> [Buch]
gelieheneBcher2 db p = [ [buch] | (ben,[buch])<- db, ben == p]

--leiher2 :: Datenbank -> Buch -> [Benutzer]
--leiher2 db b = [ ben | (ben, [buch]) <- db, filter (== b) [buch] ]

--anzGelBcher2:: Datenbank -> Benutzer -> Int
--anzGelBcher2 db p = length (gelieheneBcher2 db p)

--anzEntliehen2 db b = length (leiher2 db b)
-- Schreibende Funktionen (Update functions)

--ausleihe2 :: Datenbank -> Benutzer -> Buch -> Datenbank
--ausleihe2 db p b = (p,b) : db

--rckgabe2 :: Datenbank -> Benutzer -> Buch -> Datenbank
--rckgabe2 [] p b = error ("Der Benutzer " ++ p ++ "hat das Buch " ++ b ++
--                        "nicht entliehen und kann es daher nicht zurckgeben!")
--rckgabe2 (benbuch:db) p b = if benbuch == (p,b) then db else benbuch : rckgabe db p b

-- Aufgabe 4
sumErstesZweites::[Int]->Int
sumErstesZweites [] = 0
sumErstesZweites l = sum (take 2 l)

-- Aufgabe 5
einzig::[Int]->[Int]
einzig [] = []
einzig (a:l) = [b | b<- (a:l), count (a:l) b == 1]

