-- Aufgabe 1
-- a)
numEqual :: Num a => [a] -> a ->Int
numEqual xs x = length (filter (==x) xs)

-- b)
member :: Num a => [a] -> a -> Bool
member xs x = if numEqual xs x > 0 then True else False

-- Aufgabe 2
-- a)
class Visible a where
-- Typen, deren Werte als Strings dargestellt werden sollen
  toString :: a -> String
  size :: a -> Int
instance Visible Char where
  toString c = [c] -- '[' ++ [c] ++ ']'
  size _ = 1
instance Visible Int where
  toString x = show x 
  size i = length (toString i)

instance Visible a => Visible [a] where
  toString [] = []
  toString (x:xs) = "[" ++ toString x ++ "," ++ toString xs ++ "]"
  size = foldr (+) 1 . map size

