-- Aufgabe 1: Logische Implikation in verschiedenen Varianten

-- a. Musteranpassung (Pattern-Matching)
impA::Bool->Bool->Bool
impA True True = True
impA True False = False
impA False True = True
impA False False = True

-- b. Zurckfhrung auf logische Operatoren
impB::Bool->Bool->Bool
impB t1 t2 = not (t1 && not t2)

-- c. Mischform
impC::Bool->Bool->Bool
impC True t = t
impC False t = True

--Aufgabe 4: Verbesserung des Parkplatzproblemes
p::Int->Int->Int
p n r 
  | n < 0 = error("weniger Fahrzeuge als 0 ?!")
  | 2*n > r || r > 4*n = error("Die Anzahl der Rdern ist zu gro bzw. zu klein!")
  | odd r = error("Nur gerade Anzahl von Rdern zulssig!")
  | otherwise = (div r 2)-n

